* THIS IS A SIMPLE BROWSE UTILITY THAT ALLOWS USERS TO SET UP THEIR OWN BROWSE WINDOWS.
* IT SHOULD BE EASY TO INTEGRATE BRWSUTIL WITH YOUR EXISTING APPLICATIONS -
* NO 'SET' COMMANDS ARE USED (EXCEPT TALK - AND IT IS THEN RESTORED) -
* NO 'ON X' COMMANDS, AND NO PUBLIC VARIABLES ARE USED.
* IF A FILE IS OPEN AT STARTUP, IT IS RESELECTED BEFORE RETURNING.
* BRWSUTIL REQUIRES THE FOLLOWING FILES:
* BRWSETUP.DBF,BRWSETUP.CDX,BRWSETUP.FPT,DBFSTRC.DBF,DBFSTRC.CDX,FLDSTRC.DBF,FLDSTRC.CDX,
* SPCSTRC.DBF,SPCSTRC.CDX,SPCSTRC.FPT.
* USING THE PROGRAM IS SIMPLE - EITHER CREATE A NEW SETUP OR USE AN EXISTING ONE.
* TO CREATE A NEW ONE, JUST PUT AN X NEXT TO THE DESIRED FIELD AND FILL IN FROM-TO VALUES (OPTIONAL).
* TO USE A SETUP, JUST ARROW TO IT AND HIT ESCAPE. A SCREEN FOR ENTERING TEMPORARY FROM-TO VALUES
* (TO BE IN EFFECT FOR JUST THIS ONE TIME) WILL APPEAR BEFORE ENTERING THE BROWSE WINDOW.
* AFTER ESCAPING FROM THE BROWSE WINDOW, THE PROGRAM WILL ASK IF YOU WANT TO PRINT A LIST.
* 1995 UPDATE: NOW PRINTS TO SCREEN, PRINTER, FILE; CROSSTAB; MULTIPLE FILE WITH AUTO SET RELATION.
* (C) COPYRIGHT 1994. NO WARRANTIES EXPRESSED OR IMPLIED AND LIKE THAT THERE.
* ANOTHER FINE (?) PROGRAM FROM
* THE COLSTEN COMPUTER COUNCIL, 244 RED BUD ROAD, CHICORA, PA 16025

IF SET("TALK") = "ON"
   SET TALK OFF
   SVTALKLLC = "ON"
ELSE
   SVTALKLLC = "OFF"
ENDIF   
* SAVE FOXPRO ENVIRONMENT TO RESTORE
VIEWNAMLLC = SYS(3)
CREATE VIEW (VIEWNAMLLC)
* EASIER TO CLOSE DATABASES EACH TIME RATHER THAN CHECK TO SEE IF OPEN AND WHAT RELATIONS EXIST
CLOSE DATABASES
DEFINE WINDOW BRWINLLC FROM 1,0 TO 24,79
FILNAMLLC = ""
USE BRWSETUP IN 0 ORDER 1
SELECT BRWSETUP

* SHOW MAIN SELECTION SCREEN
DO WHILE BRWNAMELLC <> " EXIT THIS SCREEN"

   BROWSE NORMAL WINDOW BRWINLLC NOAPPEND TITLE "USE ARROW KEYS TO SELECT CHOICE. ESCAPE TO CONTINUE.";
      FIELDS BRWNAMELLC :H = "SETUP NAME" :V = RECNO() > 2

   DO CASE

      CASE BRWNAMELLC = " CREATE NEW SETUP"
         DO CRNEWLLC
         CLOSE DATABASES
         USE BRWSETUP IN 0 ORDER 1
         SELECT BRWSETUP

      CASE BRWNAMELLC <> " EXIT THIS SCREEN"
         DO USEEXLLC
         CLOSE DATABASES
         USE BRWSETUP IN 0 ORDER 1
         SELECT BRWSETUP

   ENDCASE

ENDDO   

WAIT "Please wait..." WINDOW NOWAIT
* CLOSE BRWSETUP
USE
RELEASE WINDOW BRWINLLC
* RESTORE FOXPRO ENVIRONMENT
SET VIEW TO (VIEWNAMLLC)
DELETE FILE (VIEWNAMLLC + ".VUE")
SET TALK &SVTALKLLC
WAIT CLEAR
RETURN

*** CREATE A NEW SETUP SUBROUTINE
FUNCTION CRNEWLLC

* DELETE FILES FIRST TO AVOID MESSAGES
DELETE FILE DBFLIST.TXT
DELETE FILE DBFLIST.DBF
DELETE FILE DBFLIST.CDX
FILNAMLLC = ""
* THIS IS A WAY TO CREATE AN EMPTY FILE WITHOUT ZAP OR DELETE & PACK
USE DBFSTRC IN 0
SELECT DBFSTRC
COPY TO DBFLIST WITH CDX
* CLOSE DBFSTRC
USE
USE DBFLIST IN 0 ORDER 1
SELECT DBFLIST
* OPEN SPECIAL FILE TO SEE IF SPCNLSTLLC FIELD (DONT LIST) IS CHECKED
USE SPCSTRC IN 0 ORDER 1
SELECT SPCSTRC
* STORE DBF FILENAMES 1 BY 1 AFTER VALIDITY CHECK
FILNAMLLC = SYS(2000,"*.DBF")

DO WHILE FILNAMLLC > " "

   * IF FILENAME IS NOT LISTED IN SPCSTRC OR IF NO LIST FLAG IS NOT ON (I LOVE DOUBLE NEGATIVES), THEN INSERT INTO DBFLIST
   IF ( SEEK(FILNAMLLC) = .F. ) OR ( ( SEEK(FILNAMLLC) = .T. ) AND ( SPCNLSTLLC <> .T. ) )
      INSERT INTO DBFLIST (DBFFORILLC) VALUES (LEFT(FILNAMLLC, LEN(FILNAMLLC) - 4))
   ENDIF

   * GET NEXT DBF FILENAME
   FILNAMLLC = SYS(2000,"*.DBF",1)

ENDDO

* CLOSE SPCSTRC
USE
SELECT DBFLIST
GO TOP
FLCHORDLLC = 0
FILNAMSLLC = ""
RELSTRLLC = ""

* BROWSE DBFLIST TO PICK WHICH FILE
BROWSE NORMAL WINDOW BRWINLLC TITLE "PUT X NEXT TO DESIRED FILE(S). ESCAPE TO CONTINUE.";
   FIELDS DBFFORILLC :R :H = "FILENAME",;
      FLDXLLC :V = INCFLDOLLC() :H = "X"

WAIT "Please wait..." WINDOW NOWAIT
* IF YOU ONLY WANT ONE FILE, USE THE CURRENT ONE - OR IN CASE THEY FORGET TO "X" ANY
IF FILNAMSLLC <= " "
   FILNAMSLLC = RTRIM(DBFFORILLC)
ENDIF
* CLOSE DBFLIST
USE
* DELETE TEMPORARY FILES
DELETE FILE DBFLIST.TXT
DELETE FILE DBFLIST.DBF
DELETE FILE DBFLIST.CDX
* DELETE FILES FIRST TO AVOID MESSAGES
DELETE FILE FLDLIST.DBF
DELETE FILE FLDLIST.CDX
* THIS IS A WAY TO CREATE AN EMPTY FILE WITHOUT ZAP OR DELETE & PACK
USE FLDSTRC IN 0
SELECT FLDSTRC
COPY TO FLDLIST WITH CDX
* CLOSE FLDSTRC
USE
USE FLDLIST IN 0 ORDER 1
PRVCOMLLC = 1

* GET FIELD LIST FOR EACH FILE AND INDEX TAG LIST FOR FIRST FILE
FOR I = 1 TO ( OCCURS(",", FILNAMSLLC) + 1 )

   DO GETFILNLLC
   * GET FIELD LIST FOR FILNAMLLC
   DO GETFLDNLLC

   * CREATE INDEX TAG LIST FOR FIRST FILE
   IF I = 1

      * THIS IS A WAY TO CREATE AN EMPTY FILE WITHOUT ZAP OR DELETE & PACK
      USE DBFSTRC IN 0
      SELECT DBFSTRC
      COPY TO DBFLIST WITH CDX
      * CLOSE DBFSTRC
      USE
      SELECT (FILNAMLLC)
      * USE DBFLIST TO HOLD INDEX TAG NAMES - USE DBFLIST STATEMENT NOT NEEDED
      FOR J = 1 TO 256
         IF EMPTY(TAG(J))
            EXIT
         ENDIF   
         INSERT INTO DBFLIST (DBFFORILLC) VALUES (TAG(J,FILNAMLLC))
      NEXT J

   ENDIF

NEXT I

* SET UP BROWSE WINDOW FOR CHOOSING DESIRED FIELDS, FROMTO VALUES
SELECT FLDLIST
GO TOP
FLCHORDLLC = 0
* NOT TO BE NASTY... BUT IF THEY DON'T FIX IT, THEY PROBABLY WON'T GET THE DESIRED RESULT
PROBLLC = 1
BASERRLLC = ""
* FLAG IF USING EXISTING SETUP 
USESETLLC = .F.
WAIT CLEAR

DO WHILE PROBLLC = 1
   BROWSE NORMAL WINDOW BRWINLLC TITLE "PUT X NEXT TO DESIRED FIELD,ENTER FROM-TO VALUES. ESCAPE TO CONTINUE." VALID :F BASCHKLLC() ERROR BASERRLLC;
      FIELDS FIELD_NAME :R,;
      FLDXLLC :V = INCFLDOLLC() :H = "X",;
      FLDFRMVLLC :25 :H = "SHOW NONE LESS THAN",;
      FLDTOVLLC :25 :H = "SHOW NONE GREATER THAN",;
      FLDORLLC :H = "OR" :V = DUPLCORLLC()
ENDDO      

* SHOW LIST OF INDEX TAG NAMES IF THERE IS AT LEAST ONE
IF USED("DBFLIST")

   * BROWSE WINDOW FOR INDEX TAG NAMES
   SELECT DBFLIST
   SET ORDER TO 1
   GO TOP
   BROWSE NORMAL WINDOW BRWINLLC TITLE "USE ARROW KEYS TO SELECT DESIRED INDEX TAG (SORTBY). ESCAPE TO CONTINUE.";
      FIELDS DBFFORILLC :R :H = "SORT BY"

   * SAVE INDEX TAG NAME
   SORTBYLLC = DBFFORILLC
   INDXBYLLC = ""
   * CLOSE DBFLIST
   USE
ELSE
   * THERE IS NO COMPUND INDEX FILE BUT MAYBE THERE ARE ASSOCIATED IDX FILES
   WAIT "Highlite sort (index) for " + FILNAMLLC + ", then hit enter - hit enter for list" WINDOW
   SELECT (FILNAMLLC)
   SET INDEX TO ?
   SORTBYLLC = ""
   INDXBYLLC = TAG(1)
   
ENDIF

* DELETE TEMPORARY FILES
DELETE FILE DBFLIST.DBF
DELETE FILE DBFLIST.CDX
FLDLISLLC = ""
COMSTRLLC = ""
FROMTOLLC = ""
ANDSTRLLC = ""
REPHEADLLC = ""
NFLDLISLLC = ""
NCOMSTRLLC = ""
SAVFLDNLLC = " "
SAVFLORLLC = ""
DELIM1LLC = ""
DELIM2LLC = ""
* GO THRU FIELD LIST IN CHOSEN ORDER
SELECT FLDLIST
SET ORDER TO 2

* SAVE REQUESTED INFO
SCAN FOR FLDXLLC > " "

      * CREATE FIELD LIST - CHECK TO MAKE SURE FIELD IS NOT DUPLICATE BECAUSE OF 'OR'
      IF FIELD_NAME <> SAVFLDNLLC
         FLDLISLLC = FLDLISLLC + COMSTRLLC + RTRIM(FIELD_NAME)
      ENDIF
        
      * CREATE REPORT HEADER
      IF FIELD_NAME <> SAVFLDNLLC
         FNONLYLLC = RIGHT(RTRIM(FIELD_NAME), ( LEN(RTRIM(FIELD_NAME)) - AT(".", FIELD_NAME) ))
         REPHEADLLC = REPHEADLLC + LEFT( FNONLYLLC, FIELD_LEN) + " "
         FOR I = 1 TO ( FIELD_LEN - LEN(FNONLYLLC) )
            REPHEADLLC = REPHEADLLC + " "
         NEXT I
      ENDIF

      * CREATE FIELD STRING OF NUMERIC FIELDS FOR TOTALS
      IF FIELD_TYPE = "N"
         IF FIELD_NAME <> SAVFLDNLLC
            NFLDLISLLC = NFLDLISLLC + NCOMSTRLLC + FIELD_NAME
         ENDIF
         
         * AFTER FIRST ONE SET COMMA STRING TO ", "
         NCOMSTRLLC = ", "

         * IF NUMERIC FIELD IS LEFT BLANK
         IF ( FLDFRMVLLC <= " " ) AND ( FLDTOVLLC > " " )
            REPLACE FLDFRMVLLC WITH "0"
         ENDIF
         IF ( FLDTOVLLC <= " " ) AND ( FLDFRMVLLC > " " )
            REPLACE FLDTOVLLC WITH "0"
         ENDIF
      ENDIF
 
      * AFTER FIRST ONE SET COMMA STRING TO ", "
      COMSTRLLC = ", "      

   * CHARACTER & DATE TYPE FIELDS MUST HAVE DELIMITERS
   DO FTDELIMLLC     

   * CREATE FROM-TO LIST - USE "OR" WITH 2 SPACES AFTERWARD FOR STANDARD REPLACEMENT LATER ON
   IF ( FLDFRMVLLC > " " ) OR ( FLDTOVLLC > " " )
      IF FROMTOLLC > " "
         IF SAVFLORLLC > " "
            FROMTOLLC = FROMTOLLC + " OR  " + "BETWEEN(" + RTRIM(FIELD_NAME) + "," + DELIM1LLC + RTRIM(FLDFRMVLLC) + DELIM2LLC + "," + DELIM1LLC + RTRIM(FLDTOVLLC) + DELIM2LLC + ")"
         ELSE
            FROMTOLLC = FROMTOLLC + " AND " + "BETWEEN(" + RTRIM(FIELD_NAME) + "," + DELIM1LLC + RTRIM(FLDFRMVLLC) + DELIM2LLC + "," + DELIM1LLC + RTRIM(FLDTOVLLC) + DELIM2LLC + ")"
         ENDIF
      ELSE
         FROMTOLLC = "BETWEEN(" + RTRIM(FIELD_NAME) + "," + DELIM1LLC + RTRIM(FLDFRMVLLC) + DELIM2LLC + "," + DELIM1LLC + RTRIM(FLDTOVLLC) + DELIM2LLC + ")"
      ENDIF
   ENDIF
   * SAVE 'OR' MARK TO DETERMINE WHETHER TO 'AND' OR 'OR' WITH THE NEXT FIELD
   SAVFLDNLLC = FIELD_NAME   
   SAVFLORLLC = FLDORLLC
   
ENDSCAN      

* CLOSE FLDLIST
USE
* DELETE TEMPORARY FILES
DELETE FILE FLDSEX.DBF
DELETE FILE FLDLIST.DBF
DELETE FILE FLDLIST.CDX
SELECT BRWSETUP

* ADD A RECORD FOR NEWLY CREATED FIELD LIST
IF FLDLISLLC > " "
   APPEND BLANK
   REPLACE BRWNAMELLC WITH "ZZZ"
   REPLACE BRWFILNLLC WITH FILNAMSLLC
   REPLACE BRWSORTLLC WITH SORTBYLLC
   REPLACE BRWFLDLLLC WITH FLDLISLLC
   REPLACE BRWRELALLC WITH RELSTRLLC
   REPLACE BRWINDXLLC WITH INDXBYLLC
   IF FROMTOLLC > " "
      REPLACE BRWFRTOLLC WITH ( " FOR " + FROMTOLLC )
   ENDIF   
   REPLACE BRWREPHLLC WITH REPHEADLLC
   REPLACE BRWNFLDLLC WITH NFLDLISLLC
   WAIT "Please change ZZZ to your desired new name and hit enter when done" WINDOW NOWAIT
ENDIF   
RETURN

*** DISPLAY BROWSE WINDOW USING EXISTING SETUP
FUNCTION USEEXLLC

WAIT "Goto Edit screen, Print list, Cross tab summary? (E/P/C)" TO WAITEPCLLC WINDOW
WAITEPCLLC = UPPER(WAITEPCLLC)
IF WAITEPCLLC <> "E"
   WAIT "Output to Screen, Printer, File=(Brwsutil.txt) (S/P/F)" TO WAITSPFLLC WINDOW
   WAITSPFLLC = UPPER(WAITSPFLLC)
ENDIF
WAIT "Please wait..." WINDOW NOWAIT
* SAVE CHOSEN FILE(S) AND FIELDS FROM BRWSETUP
FILNAMSLLC = RTRIM(BRWFILNLLC)
FLDLISLLC = BRWFLDLLLC
FROMTOLLC = BRWFRTOLLC
SORTBYLLC = BRWSORTLLC
SAVETOLLC = BRWSAVFLLC
REPHEADLLC = RTRIM(BRWREPHLLC)
NFLDLISLLC = BRWNFLDLLC
RELATNLLC = BRWRELALLC
INDXBYLLC = BRWINDXLLC
ADDINSTLLC = ""
* OPEN SPCSTRC TO CHECK FILENAME AND TO GET SPCADINLLC FIELD (ADDITIONAL INSTRUCTIONS)
USE SPCSTRC IN 0 ORDER 1
* DELETE FILES FIRST TO AVOID MESSAGES
DELETE FILE FLDLIST.DBF
DELETE FILE FLDLIST.CDX
* THIS IS A WAY TO CREATE AN EMPTY FILE WITHOUT ZAP OR DELETE & PACK
USE FLDSTRC IN 0
SELECT FLDSTRC
COPY TO FLDLIST WITH CDX
* CLOSE FLDSTRC
USE
USE FLDLIST IN 0 ORDER 1
PRVCOMLLC = 1
PARPCOMLLC = 1
SETSKIPLLC = ""
PARFILLLC = ""
RELINDXLLC = ""

* UNSTRING FILE NAMES FROM MEMO FIELD AND ALSO PARENT AND RELATION NAMES
FOR I = 1 TO ( OCCURS(",", FILNAMSLLC) + 1 )

   * GET SINGLE FILE NAME
   DO GETFILNLLC
   SELECT SPCSTRC
   * CHECK TO SEE IF A USER MANUALLY CHANGED FILENAME IN BRWSETUP
   IF SEEK(FILNAMLLC)
      IF SPCNLSTLLC = .T.
         WAIT "File acces denied - shame on you!" WINDOW
         RETURN
      ENDIF
      * SAVE FIRST ( YOU CAN'T SAVE THEM ALL WITH MULTIPLE FILES ) ADDITIONAL INSTRUCTIONS
      IF ADDINSTLLC <= " "
         ADDINSTLLC = SPCADINLLC
      ENDIF
   ENDIF
  
   * GET FIELD LIST FOR FILNAMLLC
   DO GETFLDNLLC
   IF I = 1
      FSTFILLLC = FILNAMLLC
   ELSE
      * UNSTRING PARENT AND RELATION
      RELFLDLLC = ""
      DO UNPARELLLC
      * COMPUND STRUCTURAL INDEX FILE
      IF SORTBYLLC > " "
         SET ORDER TO (RELINDXLLC)
      ENDIF
      * IDX FILES
      IF INDXBYLLC > " "
         SET INDEX TO (RELINDXLLC)
      ENDIF
      SELECT (PARFILLLC)
      SET RELATION TO &RELFLDLLC INTO (FILNAMLLC) ADDITIVE
      IF PARFILLLC = FSTFILLLC
         * BUILD SET SKIP TO STRING
         IF SETSKIPLLC <= " "
            SETSKIPLLC = FILNAMLLC
         ELSE
            SETSKIPLLC = SETSKIPLLC + "," + FILNAMLLC
         ENDIF
      ENDIF
   ENDIF

NEXT I

SELECT SPCSTRC
USE
SELECT FLDLIST
* SET UP BROWSE WINDOW TO FILL IN
GO TOP
PROBLLC = 1
BASERRLLC = ""
USESETLLC = .T.
* FLCHORDLLC NOT REALLY USED BUT INITIALIZE IT FOR DUPLCORLLC CALL
FLCHORDLLC = 0
WAIT CLEAR

DO WHILE PROBLLC = 1
   BROWSE NORMAL WINDOW BRWINLLC TITLE "ENTER TEMPORARY FROM-TO VALUES FOR JUST THIS TIME. ESCAPE TO CONTINUE." VALID :F BASCHKLLC() ERROR BASERRLLC;
      FIELDS FIELD_NAME :R,;
      FLDFRMVLLC :26 :V = INCFLDOLLC() :H = "SHOW NONE LESS THAN",;
      FLDTOVLLC :26 :V = INCFLDOLLC() :H = "SHOW NONE GREATER THAN   ",;
      FLDORLLC :H = "OR" :V = DUPLCORLLC()
ENDDO

TEMPFTLLC = ""
ANDSTRLLC = ""
SAVFLDNLLC = " "
SAVFLORLLC = ""
DELIM1LLC = ""
DELIM2LLC = ""
* GO THRU FIELD LIST IN CHOSEN ORDER - IMPORTANT HERE FOR 'OR' FIELD - THAT'S WHY YOU NEED :V = INCFLDOLLC FOR TEMPS
SET ORDER TO 2
* CREATE TEMPORARY FROM-TO STRING
SCAN FOR ( FLDFRMVLLC > " " ) OR ( FLDTOVLLC > " " )      

   * CHARACTER & DATE TYPE FIELDS MUST HAVE DELIMITERS
   DO FTDELIMLLC     
   * IF NUMERIC FIELD IS LEFT BLANK
   IF FIELD_TYPE = "N"
      IF ( FLDFRMVLLC <= " " ) AND ( FLDTOVLLC > " " )
         REPLACE FLDFRMVLLC WITH "0"
      ENDIF
      IF ( FLDTOVLLC <= " " ) AND ( FLDFRMVLLC > " " )
         REPLACE FLDTOVLLC WITH "0"
      ENDIF
   ENDIF   

   * SAVE TEMPORARY FROM-TO LIST 
   IF TEMPFTLLC > " "
      IF SAVFLORLLC > " "
         TEMPFTLLC = TEMPFTLLC + " OR  " + "BETWEEN(" + RTRIM(FIELD_NAME) + "," + DELIM1LLC + RTRIM(FLDFRMVLLC) + DELIM2LLC + "," + DELIM1LLC + RTRIM(FLDTOVLLC) + DELIM2LLC + ")"
      ELSE
         TEMPFTLLC = TEMPFTLLC + " AND " + "BETWEEN(" + RTRIM(FIELD_NAME) + "," + DELIM1LLC + RTRIM(FLDFRMVLLC) + DELIM2LLC + "," + DELIM1LLC + RTRIM(FLDTOVLLC) + DELIM2LLC + ")"
      ENDIF
   ELSE
      TEMPFTLLC = "BETWEEN(" + RTRIM(FIELD_NAME) + "," + DELIM1LLC + RTRIM(FLDFRMVLLC) + DELIM2LLC + "," + DELIM1LLC + RTRIM(FLDTOVLLC) + DELIM2LLC + ")"
   ENDIF
   SAVFLDNLLC = FIELD_NAME
   SAVFLORLLC = FLDORLLC
   
ENDSCAN      

* CLOSE FLDLIST
USE
* DELETE TEMPORARY FILES
DELETE FILE FLDSEX.DBF
* ADJUST SETUP FROM TO WITH TEMPORARY FROM TO VALUES
DO CASE
   CASE ( FROMTOLLC > "  " ) AND ( TEMPFTLLC > " " )
      FROMTOLLC = FROMTOLLC + " AND " + TEMPFTLLC
   CASE ( FROMTOLLC <= " " ) AND ( TEMPFTLLC > " " )
      FROMTOLLC = " FOR " + TEMPFTLLC
ENDCASE         
     
* SELECT THE DESIRED FILE, SET ORDER AND SKIP TO
SELECT (FSTFILLLC)
IF SORTBYLLC > " "
   SET ORDER TO (SORTBYLLC)
ENDIF   
IF INDXBYLLC > " "
   SET INDEX TO (INDXBYLLC)
ENDIF
IF SETSKIPLLC > " "
   SET SKIP TO &SETSKIPLLC
ENDIF

IF WAITEPCLLC = "E"
   * YOUR WAY RIGHT AWAY
   COUNT &FROMTOLLC TO CNTSELLLC
   WAIT ( "There are " + LTRIM(STR(RECCOUNT())) + " records in the main file; " + LTRIM(STR(CNTSELLLC)) + " listed here") WINDOW NOWAIT
   GO TOP
   BROWSE NORMAL WINDOW BRWINLLC FIELDS &FLDLISLLC &FROMTOLLC &ADDINSTLLC
ENDIF   

* COPY TO A FILE IF ONE WAS REQUESTED
IF SAVETOLLC > " "
   COPY TO (SAVETOLLC) FIELDS &FLDLISLLC &FROMTOLLC
ENDIF   
* INITIALIZE VARS EVEN IF PRINTING TO SCREEN - SET PRINTER TO IS NOT SAVED IN VIEW
_PLINENO = 0
SVPRSTALLC = SET("PRINTER",1)

*IF THEY JUST CAME OUT OF EDIT SCREEN
IF WAITEPCLLC = "E"
   WAIT "Print list, Cross tab summary, end? (P/C/E)" TO WAITEPCLLC WINDOW
   WAITEPCLLC = UPPER(WAITEPCLLC)
   IF WAITEPCLLC <> "E"
      WAIT "Output to Screen, Printer, File=(Brwsutil.txt) (S/P/F)" TO WAITSPFLLC WINDOW
      WAITSPFLLC = UPPER(WAITSPFLLC)
   ENDIF
ENDIF

IF WAITEPCLLC <> "E"
   IF WAITSPFLLC = "S"
      ACTIVATE WINDOW BRWINLLC
   ELSE
     SET PRINTER ON
     IF WAITSPFLLC = "F"
        SET PRINTER TO "BRWSUTIL.TXT"
     ENDIF
  ENDIF
ENDIF

* PRINT LIST
IF WAITEPCLLC = "P"
   WAIT "Only print totals? (Y/N)" TO WAITANSLLC WINDOW
   WAITANSLLC = UPPER(WAITANSLLC)
     
   * CHANGE ANY CALCULATED FIELDS (WHICH MAY HAVE BEEN TYPED IN MANUALLY) FROM FORM (A = B * C) TO FORM (B * C) FOR PRINTING
   LASTCOMLLC = 0
   FOR I = 1 TO LEN(FLDLISLLC)
      IF SUBSTR(FLDLISLLC,I,1) = ","
         LASTCOMLLC = I
      ENDIF
      IF SUBSTR(FLDLISLLC,I,1) = "="
         FLDLISLLC = STUFF(FLDLISLLC, LASTCOMLLC + 1, I - LASTCOMLLC, "")
      ENDIF
   NEXT I   

   * PRINT LIST HEADING
   DO LINCHKLLC
   * PRINT CHOSEN RECORDS AND FIELDS
   IF WAITANSLLC <> "Y"
      SCAN &FROMTOLLC
         DO LINCHKLLC
         ? &FLDLISLLC
      ENDSCAN   
   ENDIF   

   * ONLY PRINT TOTALS FOR NUMERIC FIELDS
   IF NFLDLISLLC > " "
      IF _PLINENO > 19
         WAIT WINDOW
      ENDIF   
      ? ""
      ? "TOTALS"
      SET TALK ON
      SUM &NFLDLISLLC &FROMTOLLC
      ? ""
      SET TALK OFF
   ENDIF   

   IF WAITSPFLLC = "S"
      WAIT WINDOW
   ENDIF   
   @ 0,0 CLEAR

ENDIF   

* CROSS TAB
IF WAITEPCLLC = "C"
   DO CRSTABLLC
ENDIF

SET PRINTER OFF
SET PRINTER TO &SVPRSTALLC
DEACTIVATE WINDOW BRWINLLC
* DELETE TEMPORARY FILES
DELETE FILE TMP1LLC.DBF
DELETE FILE TMP2LLC.DBF
DELETE FILE FLDLIST.DBF
DELETE FILE FLDLIST.CDX
PRVCOMLLC = 1

* GO BACK TO MAIN WINDOW
SELECT BRWSETUP
RETURN

*** KEEP TRACK OF THE ORDER FIELDS ARE CHOSEN
FUNCTION INCFLDOLLC

FLCHORDLLC = FLCHORDLLC + 1
REPLACE FLDFORDLLC WITH FLCHORDLLC

* IF YOU ARE GETTING FILES - GO CHECK RELATIONS
IF ALIAS() = "DBFLIST"
   DO FILSCHKLLC
ENDIF
RETURN

*** BASIC CHECKS ON FROM TO VALUES
FUNCTION BASCHKLLC

PROBLLC = 0
IF ( FLDFRMVLLC > " " ) AND ( FIELD_TYPE = "D" ) AND ( CTOD(FLDFRMVLLC) = {} )
   BASERRLLC = "WARNING! INVALID DATE FIELD - PLEASE INPUT FORMAT MM/DD/YY"
   PROBLLC = 1
ENDIF
IF ( FLDTOVLLC > " " ) AND ( FIELD_TYPE = "D" ) AND ( CTOD(FLDTOVLLC) = {} )
   BASERRLLC = "WARNING! INVALID DATE FIELD - PLEASE INPUT FORMAT MM/DD/YY"
   PROBLLC = 1   
ENDIF
IF ( FIELD_TYPE = "D" ) AND ( CTOD(FLDFRMVLLC) > CTOD(FLDTOVLLC) )
   BASERRLLC = "WARNING! <LESS THAN< IS GREATER THAN >GREATER THAN> ?"
   PROBLLC = 1
ENDIF
IF ( FIELD_TYPE = "N" ) AND ( VAL(FLDFRMVLLC) > VAL(FLDTOVLLC) )
   BASERRLLC = "WARNING! <LESS THAN< IS GREATER THAN >GREATER THAN> ?"
   PROBLLC = 1
ENDIF
IF ( FIELD_TYPE = "C" ) AND ( FLDFRMVLLC > FLDTOVLLC )
   BASERRLLC = "WARNING! <LESS THAN< IS GREATER THAN >GREATER THAN> ?"
   PROBLLC = 1
ENDIF   
IF PROBLLC = 1
   RETURN .F.
ENDIF   
* SKIP THE FOLLWING CHECKS IF YOU ARE CREATING A SETUP
IF USESETLLC = .F.
   RETURN
ENDIF
FLDNAMLLC = RTRIM(FIELD_NAME)

* SEE IF FROM-TO VALUES WERE ENTERED WHEN SETUP WAS CREATED
FLDATLLC = ATC(FLDNAMLLC, FROMTOLLC)
IF ( FLDATLLC > 0 ) AND ( ( FLDFRMVLLC > " " ) OR ( FLDTOVLLC > " " ) )

   * FIND END OF FROM-TO VALUES FOR THIS FIELD
   FLDENDLLC = 1
   ANDCTRLLC = 0
   * FIND THE FIRST " AND " -OR- " OR (" AFTER FLDNAMLLC OR QUIT IF NO " AND " -OR- " OR (" IS FOUND
   DO WHILE ( FLDENDLLC < FLDATLLC ) AND ( FLDENDLLC > 0 )
      ANDCTRLLC = ANDCTRLLC + 1
      FLDENDLLC = ATC(" AND ", FROMTOLLC, ANDCTRLLC)
      * LOOK FOR " OR (" IF YOU HAVEN'T FOUND AN " AND "
      IF FLDENDLLC = 0
         FLDENDLLC = ATC(" OR  ", FROMTOLLC, ANDCTRLLC)
      ENDIF
   ENDDO

   * THERE IS NO " AND " -OR- " OR  " AFTER FIELD_NAME
   IF FLDENDLLC = 0
      * IS THERE AN " AND " -OR- " OR  " BEFORE FIELD_NAME
      IF ( SUBSTR(FROMTOLLC, ( FLDATLLC - 13 ), 5 ) = " AND " ) OR ( SUBSTR(FROMTOLLC, ( FLDATLLC - 13 ), 5 ) = " OR  " )
         * MAKE END EQUAL TO LENGTH     
         FLDENDLLC = LEN(FROMTOLLC)
         * ADJUST WHERE SUBSTITUTION STARTS
         ANDADJLLC = 5
         * THERE IS AN " AND " -OR- " OR  "
         ANDFLAGLLC = .T.
      ELSE   
         * NO " AND " -OR- " OR  " ANYWHERE
         FLDENDLLC = LEN(FROMTOLLC)
         ANDADJLLC = 0
         ANDFLAGLLC = .F.
      ENDIF
   * THERE WAS AN " AND " -OR- " OR  " AFTER FIELD_NAME
   ELSE
      FLDENDLLC = FLDENDLLC - 1
      ANDADJLLC = 0
      ANDFLAGLLC = .T.
   ENDIF
   
   * MAKE SURE THEY DON'T TYPE RIGHT THRU IT BEFORE THEY READ IT
   WAITANSLLC = ""
   DO WHILE WAITANSLLC <> "Z"
      WAIT ( "Setup values (" + LEFT(SUBSTR(FROMTOLLC, FLDATLLC, FLDENDLLC - FLDATLLC ), 33) + ") already entered - hit Z") TO WAITANSLLC WINDOW
      WAITANSLLC = UPPER(WAITANSLLC)      
   ENDDO   
   WAIT "Use the new values that you just entered instead? (Y/N)" TO WAITANSLLC WINDOW
   WAITANSLLC = UPPER(WAITANSLLC)
   IF WAITANSLLC = "Y"
      * THERE IS NO " AND " -OR- " OR  " - JUST ELIMINATE THE ONLY FROM-TO ( THE ONE THAT WAS JUST RE-ENTERED )
      IF ANDFLAGLLC = .F.
         FROMTOLLC = ""
      ELSE   
         * THERE IS AN " AND " -OR- " OR  " BEFORE OR AFTER FIELD_NAME
         FROMTOLLC = STUFF(FROMTOLLC, ( FLDATLLC - 8 - ANDADJLLC ), ( FLDENDLLC - FLDATLLC + 14 ), "")
      ENDIF
   * DON'T USE THE VALUES THEY JUST TYPED   
   ELSE
      REPLACE FLDFRMVLLC WITH ""
      REPLACE FLDTOVLLC WITH  ""         
   ENDIF   
ENDIF   
   
RETURN

*** DO CROSSTAB
FUNCTION CRSTABLLC

* SEE IF THERE EXACTLY 3 FIELDS IN THE SETUP AND GET THEIR NAMES
ROWFLDLLC = ""
COLFLDLLC = ""
NUMFLDLLC = ""
TMPRSTRLLC = ""
TMPRPARLLC = ""
TMPCSTRLLC = ""
TMPCPARLLC = ""

* WHICH FIELD NAME TO BUILD
FNAMBLDLLC = "ROWFLDLLC"
FOR I = 1 TO LEN(FLDLISLLC)
   ONECHRLLC = SUBSTR(FLDLISLLC,I,1)
   * WHEN YOU REACH A COMMA - START BUILDING THE NEXT FIELD
   IF ONECHRLLC = ","
      IF FNAMBLDLLC = "ROWFLDLLC"
         FNAMBLDLLC = "COLFLDLLC"
      ELSE
         FNAMBLDLLC = "NUMFLDLLC"
      ENDIF
   ENDIF
   IF ONECHRLLC > ","
      &FNAMBLDLLC = &FNAMBLDLLC + ONECHRLLC
   ENDIF
NEXT I

USE FLDLIST IN 0 ORDER 1
SELECT FLDLIST
PROBLLC = 0
IF ( NUMFLDLLC > " " ) AND ( AT(",", FLDLISLLC, 3) = 0 )
   * THERE WERE EXACTLY 3 FIELDS - GET DATA TYPE OF FIRST TWO
   SEEK(ROWFLDLLC)
   DO CHKRTYPLLC
   SEEK(COLFLDLLC)
   DO CHKCTYPLLC
   SEEK(NUMFLDLLC)
   NUMDECLLC = FIELD_DEC
   IF ( FIELD_TYPE <> "N" ) AND ( FIELD_TYPE <> "F" )
      WAIT NUMFLDLLC + " is not a numeric field - can't be totaled" WINDOW NOWAIT
      PROBLLC = 1
   ENDIF   
ELSE
   WAIT "There are not exactly 3 fields in your setup - please select exactly 3" WINDOW NOWAIT
   FLCHORDLLC = 0
   ROWFLDLLC = ""
   COLFLDLLC = ""
   NUMFLDLLC = ""
   BROWSE NORMAL WINDOW BRWINLLC TITLE "MARK (X) 3 ITEMS: THE ROW, THE COLUMN, THE NUMERIC FIELD TO BE TOTALED";
      FIELDS FIELD_NAME :R,;
         FLDXLLC :V = INCFLDOLLC() :H = "X"
   SET ORDER TO 2

   SCAN
      DO CASE
         * FIND WHICH FIELD WAS CHOSEN FOR ROW
         CASE ( ROWFLDLLC <= " " ) AND ( FLDXLLC > " " )
            ROWFLDLLC = RTRIM(FIELD_NAME)
            DO CHKRTYPLLC
          
         * AND FOR COLUMN
         CASE ( COLFLDLLC <= " " ) AND ( FLDXLLC > " " )
            COLFLDLLC = RTRIM(FIELD_NAME)
            DO CHKCTYPLLC

         * AND FOR NUMERIC FIELD
         CASE ( NUMFLDLLC <= " " ) AND ( FLDXLLC > " " )
            NUMFLDLLC = RTRIM(FIELD_NAME)
            NUMDECLLC = FIELD_DEC
            IF ( FIELD_TYPE <> "N" ) AND ( FIELD_TYPE <> "F" )
               WAIT NUMFLDLLC + " is not a numeric field - can't be totaled" WINDOW NOWAIT
               PROBLLC = 1
            ENDIF   
      ENDCASE
   ENDSCAN
ENDIF

* CLOSE FLDLIST
USE
* BUMMER
IF ( PROBLLC = 1 ) OR ( ROWFLDLLC <= " " ) OR ( COLFLDLLC <= " " ) OR ( NUMFLDLLC <= " " )
   RETURN
ENDIF   
WAIT "Please Wait..." WINDOW NOWAIT
* DELETE TEMP FILES
DELETE FILE TMP1LLC.DBF
DELETE FILE TMP2LLC.DBF

* CREATE 'WHERE CLAUSE' FROM 'FOR CLAUSE' ( REAL TUFF )
IF FROMTOLLC <= "  "
   WHERELLC = ""  
ELSE
   WHERELLC = STUFF(FROMTOLLC,2,3,"WHERE")
ENDIF      

* NOW IT IS TUFF - FOR MULTIPLE FILES - SELECT DOESN'T UNDERSTAND RELATIONS SO 'WHERE' MUST BE MODIFIED
IF RELATNLLC > " "
   PRVCOMLLC = 1
   PARPCOMLLC = 1

   FOR I = 1 TO ( OCCURS(",", FILNAMSLLC) + 1 )

      * GET SINGLE FILE NAME
      DO GETFILNLLC
      IF I > 1
         * UNSTRING PARENT AND RELATION
         RELFLDLLC = ""
         DO UNPARELLLC
         IF WHERELLC <= "  "
            WHERELLC = "WHERE " + PARFILLLC + "." + RELFLDLLC + " = " + FILNAMLLC + "." + RELFLDLLC
         ELSE
            WHERELLC = WHERELLC + " AND " + PARFILLLC + "." + RELFLDLLC + " = " + FILNAMLLC + "." + RELFLDLLC
         ENDIF
      ENDIF

   NEXT I
ENDIF

* GET ROW, COLUMN ENTRIES (TOTALS) - CONVERT NUMERIC OR DATES TO STRING TYPE FOR STRING MANIPULATIONS
SELECT &TMPRSTRLLC &ROWFLDLLC &TMPRPARLLC AS TMP1ROWLLC, &TMPCSTRLLC &COLFLDLLC &TMPCPARLLC AS TMP1COLLLC, SUM(&NUMFLDLLC) AS TMP1NUMLLC FROM &FILNAMSLLC &WHERELLC ORDER BY &ROWFLDLLC, &COLFLDLLC GROUP BY &ROWFLDLLC, &COLFLDLLC INTO DBF TMP1LLC

* GET LONGEST ROW LENGTH
CALCULATE MAX(LEN(RTRIM(TMP1LLC.TMP1ROWLLC))) TO ROWWIDLLC
* GET LONGEST NUMBER
CALCULATE MAX(LEN(LTRIM(STR(TMP1LLC.TMP1NUMLLC,20,NUMDECLLC)))) TO COLWID1LLC
* GET CROSS TAB TOTAL FOR LENGTH AND FOR PRINTING
SUM(TMP1LLC.TMP1NUMLLC) TO REPTOTLLC
CALCULATE MAX(LEN(LTRIM(STR(REPTOTLLC,20,NUMDECLLC)))) TO COLWID2LLC

* GET INDIVIDUAL COLUMN HEADINGS FOR PRINTING & TMP1LLC TOTALS THAT WERE 0
IF TMPCSTRLLC > " "
   * IF NUMERIC OR DATE YOU MUST SELECT FROM FILNAM AND CONVERT TO STR
   SELECT DISTINCT &TMPCSTRLLC &COLFLDLLC &TMPCPARLLC AS TMP2COLLLC FROM (FILNAMSLLC) &WHERELLC ORDER BY &COLFLDLLC INTO DBF TMP2LLC
ELSE
   * IF COLUMN IS ALREADY STRING - SAVE YOURSELF SOME TIME AND JUST GRAB COLUMNS FROM TMP1LLC
   SELECT DISTINCT TMP1COLLLC AS TMP2COLLLC FROM TMP1LLC ORDER BY TMP2COLLLC INTO DBF TMP2LLC
ENDIF   

* GET LONGEST COLUMN HEADING LENGTH
CALCULATE MAX(LEN(RTRIM(TMP2LLC.TMP2COLLLC))) TO COLWID3LLC
* COLUMN WIDTH IS LARGER OF NUMBER OF DIGTS OR COLUMN FIELD LENGTH
COLWIDLLC = MAX(COLWID1LLC, COLWID2LLC, COLWID3LLC) + 1
ZERCONLLC = REPLICATE(" ", COLWIDLLC - 1 ) + "0"

REPHEADLLC = NUMFLDLLC + " TOTALS FOR " + ROWFLDLLC + ", "+ COLFLDLLC
* CREATE CROSS TAB COLUMN HEADING
REPHEA2LLC = REPLICATE(" ", ROWWIDLLC)
SCAN
   REPHEA2LLC = REPHEA2LLC + REPLICATE(" ", COLWIDLLC - LEN(RTRIM(TMP2LLC.TMP2COLLLC))) + RTRIM(TMP2LLC.TMP2COLLLC)
ENDSCAN
IF COLWIDLLC > 6
   REPHEA2LLC = REPHEA2LLC + REPLICATE(" ", COLWIDLLC - 6) + " TOTAL"
ELSE
   REPHEA2LLC = REPHEA2LLC + " TOTAL"
ENDIF      
   
GO TOP IN "TMP1LLC"
GO TOP IN "TMP2LLC"
* SAVE TEMP 1 ROW
SVTMP1RLLC = TMP1LLC.TMP1ROWLLC
TMPTOTLLC = 0
DO LINCHKLLC

* PRINT FIRST ROW VALUE
?? RTRIM(TMP1LLC.TMP1ROWLLC) + REPLICATE(" ", ROWWIDLLC - LEN(RTRIM(TMP1LLC.TMP1ROWLLC)))

* GO THRU EACH COLUMN - PRINT TOTAL OR 0 IF THERE WAS NONE - THEN GO TO NEXT ROW
DO WHILE NOT EOF("TMP1LLC")

   DO LINCHKLLC
   IF TMP2LLC.TMP2COLLLC = TMP1LLC.TMP1COLLLC
      ?? REPLICATE (" ", COLWIDLLC - LEN(LTRIM(STR(TMP1LLC.TMP1NUMLLC,20,NUMDECLLC)))) + LTRIM(STR(TMP1LLC.TMP1NUMLLC,20,NUMDECLLC))
      TMPTOTLLC = TMPTOTLLC + TMP1LLC.TMP1NUMLLC
      SKIP 1 IN "TMP2LLC"
      SKIP 1 IN "TMP1LLC"

      * IF NEW ROW VALUE - PRINT 0'S TO END OF LINE AND GO TO TOP OF COLUMN LIST (TMP2LLC)
      IF SVTMP1RLLC <> TMP1LLC.TMP1ROWLLC
         DO WHILE NOT EOF("TMP2LLC")
            ?? ZERCONLLC
            SKIP 1 IN "TMP2LLC"
         ENDDO
         ?? REPLICATE (" ", COLWIDLLC - LEN(LTRIM(STR(TMPTOTLLC,20,NUMDECLLC)))) + LTRIM(STR(TMPTOTLLC,20,NUMDECLLC))
         ? ""
         * CHECK LINE COUNTER BEFORE STARTING A NEW LINE
         DO LINCHKLLC
         ?? RTRIM(TMP1LLC.TMP1ROWLLC) + REPLICATE(" ", ROWWIDLLC - LEN(RTRIM(TMP1LLC.TMP1ROWLLC)))
         TMPTOTLLC = 0
         GO TOP IN "TMP2LLC"
         SVTMP1RLLC = TMP1LLC.TMP1ROWLLC
      ENDIF
   ELSE
      ?? ZERCONLLC
      SKIP 1 IN "TMP2LLC"
   ENDIF

ENDDO         

* PRINT COLUMN AND REPORT TOTALS
? ""
IF ROWWIDLLC > 4
   ?? "TOTAL" + REPLICATE(" ", ROWWIDLLC - 5)
ELSE
   ?? REPLICATE(" ", ROWWIDLLC)
ENDIF
GO TOP IN TMP1LLC
SELECT TMP2LLC
GO TOP
SCAN
   * RE SELECT FILE FOR SUM TO WORK PROPERLY
   SELECT TMP1LLC
   SUM(TMP1LLC.TMP1NUMLLC) FOR TMP1LLC.TMP1COLLLC = TMP2LLC.TMP2COLLLC TO TMPTOTLLC
   ?? REPLICATE (" ", COLWIDLLC - LEN(LTRIM(STR(TMPTOTLLC,20,NUMDECLLC)))) + LTRIM(STR(TMPTOTLLC,20,NUMDECLLC))
ENDSCAN
?? REPLICATE (" ", COLWIDLLC - LEN(LTRIM(STR(REPTOTLLC,20,NUMDECLLC)))) + LTRIM(STR(REPTOTLLC,20,NUMDECLLC))
? ""

IF WAITSPFLLC = "S"
  WAIT WINDOW
ENDIF
@ 0,0 CLEAR

* CLOSE TMP2LLC
USE
SELECT TMP1LLC
USE
RETURN

*** CHECK ROW DATA TYPES FOR CROSSTAB
FUNCTION CHKRTYPLLC

DO CASE
   CASE ( FIELD_TYPE = "N" ) OR ( FIELD_TYPE = "F" )
      * YOU CAN EVEN USE MACRO SUBSTITUTION FOR FUNCTIONS - WAY COOL! - NUMERIC,DATE DATA TYPE WILL NEED TO BE CONVERTED TO STRING
      TMPRSTRLLC = "LTRIM(STR("
      * STRING FUNCTION DOESN'T AUTOMATICALLY GET THE RIGHT NUMBER OF DECIMALS
      TMPRPARLLC = ",20," + LTRIM(STR(FIELD_DEC)) + "))"
   CASE FIELD_TYPE = "D"
      TMPRSTRLLC = "DTOC("
      TMPRPARLLC = ")"
   CASE ( FIELD_TYPE <> "C" ) AND ( FIELD_TYPE <> "M" )
      WAIT "Cross Tab will not work unless data is type C,M,N,F" WINDOW NOWAIT
      PROBLLC = 1
ENDCASE
RETURN

*** CHECK COLUMN DATA TYPES FOR CROSSTAB
FUNCTION CHKCTYPLLC

DO CASE
   CASE ( FIELD_TYPE = "N" ) OR ( FIELD_TYPE = "F" )
      TMPCSTRLLC = "LTRIM(STR("
      TMPCPARLLC = ",20," + LTRIM(STR(FIELD_DEC)) + "))"
   CASE FIELD_TYPE = "D"
      TMPCSTRLLC = "DTOC("
      TMPCPARLLC = ")"
   CASE ( FIELD_TYPE <> "C" ) AND ( FIELD_TYPE <> "M" )
      WAIT "Cross Tab will not work unless data is type C,M,N,F" WINDOW NOWAIT
      PROBLLC = 1
ENDCASE
RETURN

*** CHECK LINE COUNTER WHEN PRINTING
FUNCTION LINCHKLLC

IF WAITSPFLLC = "S"
   IF _PLINENO > 21
      WAIT WINDOW
      ? ""
      _PLINENO = 0
   ENDIF   
ELSE
   IF _PLINENO > 54
      EJECT PAGE
   ENDIF   
ENDIF

* PRINT PAGE HEADINGS
IF _PLINENO = 0
   ? FILNAMSLLC, "LISTING   RUN", DATE()
   * PRINT FROM-TO INFO IF IT EXISTS
   IF FROMTOLLC > "  "
      ? SUBSTR(STRTRAN(STRTRAN(STRTRAN(FROMTOLLC,"BETWEEN",""),"AND","&")," ",""),4,999)
   ENDIF   
   ? REPHEADLLC
   ? ""
   IF WAITEPCLLC = "C"
      ? REPHEA2LLC
      ? ""
      ? ""
   ENDIF
ENDIF
RETURN

*** IF OR BOX WAS CHECKED - DUPLICATE LINE AND REDRAW BROWSE WINDOW
FUNCTION DUPLCORLLC

* FIELD COUNTER NEEDS TO BE INCREMENTED AS IF 'X' WAS CHECKED IN CASE CREATING A SETUP
FLCHORDLLC = FLCHORDLLC + 1
INSERT INTO FLDLIST (FIELD_NAME, FIELD_TYPE, FIELD_LEN, FIELD_DEC, FLDFORDLLC) VALUES (FIELD_NAME, FIELD_TYPE, FIELD_LEN, FIELD_DEC, FLCHORDLLC)
SHOW WINDOW (WTITLE()) REFRESH
RETURN

*** CHECK AND BUILD STRINGS AS FILES ARE ENTERED
FUNCTION FILSCHKLLC

SET ORDER TO 2
GO TOP
* PARENT FILE NAME, RELATION STRING, FILE NAMES STRING, RELATION EXISTS FLAG
PARFILLLC = ""
RELSTRLLC = ""
FILNAMSLLC = ""
RELEXLLC = .T.

* GO THRU FROM BEGINNING TO END EVERY TIME IN CASE THEY DELETE AN X SOMEWHERE
DO WHILE NOT EOF()

   IF FLDXLLC <= " "
      SKIP
   ELSE
      * GOT FIRST (TOP) PARENT RECORD - SAVE VERY FIRST PARENT IN ORDER TO RETURN TO IT
      CURFILLLC = RTRIM(DBFFORILLC)
      SAVCORDLLC = FLDFORDLLC
      IF PARFILLLC <= " "
         FSTPARLLC = CURFILLLC
         PARFILLLC = CURFILLLC
         FILNAMSLLC = CURFILLLC
         FSTPORDLLC = FLDFORDLLC
         SAVPORDLLC = FLDFORDLLC
      ENDIF
      * ON FIRST X YOU DON'T HAVE A CHILD SO JUST WAIT
      IF PARFILLLC <> CURFILLLC

         * OPEN PARENT & THEN CHILD - GOTTA BE OPEN TO GO THRU KEYS
         USE (PARFILLLC) IN 0
         USE (CURFILLLC) IN 0
         RELEXLLC = .F.

         FOR J = 1 TO 256

            PARKEYLLC = KEY(J, PARFILLLC)
            * THERE IS NO COMPUND INDEX FILE BUT MAYBE THERE ARE ASSOCIATED IDX FILES
            IF ( J = 1 ) AND ( PARKEYLLC  <= " " )
               WAIT "Highlite index for " + PARFILLLC + ", then hit enter - hit enter for list" WINDOW
               SELECT (PARFILLLC)
               SET INDEX TO ?
               PARKEYLLC = KEY(1)
            ENDIF

            IF PARKEYLLC <= " "
               EXIT
            ENDIF

            FOR K = 1 TO 256

               CHIKEYLLC = KEY(K, CURFILLLC)
               * THERE IS NO COMPUND INDEX FILE BUT MAYBE THERE ARE ASSOCIATED IDX FILES
               IF ( K = 1 ) AND ( CHIKEYLLC  <= " " )
                  WAIT "Highlite index for " + CURFILLLC + ", then hit enter - hit enter for list" WINDOW
                  SELECT (CURFILLLC)
                  SET INDEX TO ?
                  CHIKEYLLC = KEY(1)
               ENDIF

               IF CHIKEYLLC <= " "
                  EXIT
               ENDIF
            
	           * OH GOODY! - WE CAN SET UP A RELATION BETWEEN 2 FILES
               IF PARKEYLLC = CHIKEYLLC
                  CHITAGLLC = TAG(K, CURFILLLC)
                  RELEXLLC = .T.
                  EXIT
               ENDIF

            NEXT K

            * IF RELATION EXISTS - BUILD STRING WITH KEY NAME AND FILE NAMES LIST AND EXIT OUTER LOOP
            IF RELEXLLC = .T.
               FILNAMSLLC = FILNAMSLLC + "," + CURFILLLC
               IF RELSTRLLC <= " "
                  RELSTRLLC = PARFILLLC + "," + CHITAGLLC
               ELSE
                  RELSTRLLC = RELSTRLLC + "," + PARFILLLC + "," + CHITAGLLC
               ENDIF
               EXIT
            ENDIF

         NEXT J

         * CLOSE PARENT AND CHILD
         SELECT (PARFILLLC)
         USE
         SELECT (CURFILLLC)
         USE
         SELECT DBFLIST

      ENDIF

      * IF RELATION EXISTS - SKIP TO NEXT CHILD RECORD AND MAKE PARENT = TOP PARENT FOR NEXT SEARCH ELSE - TRY NEXT RECORD AS PARENT
      IF RELEXLLC = .T.
         PARFILLLC = FSTPARLLC
         SAVPORDLLC = FSTPORDLLC      
         SKIP      
      ELSE
         SEEK(SAVPORDLLC)
         SKIP 1
         * IF NOT EQUAL THEN MAYBE THIS FILE CAN BE PARENT - IF EQUAL THEN NO MORE POSSIBLE PARENTS SO DROP OUT
         IF PARFILLLC <> RTRIM(DBFFORILLC)
            PARFILLLC = RTRIM(DBFFORILLC)
            SAVPORDLLC = FLDFORDLLC
            * PUT POINTER BACK TO CURRENT CHILD AND TRY AGAIN
            SEEK(SAVCORDLLC)
         ENDIF
      ENDIF

   ENDIF

ENDDO

IF RELEXLLC = .F.
   WAIT CURFILLLC + " file not useable with these - no equal index - hit enter" WINDOW
   GO BOTTOM
   REPLACE FLDXLLC WITH " "
ENDIF
SELECT DBFLIST
SET ORDER TO 1
RETURN

*** GET ONE FILE NAME FROM FILNAMSLLC
FUNCTION GETFILNLLC

CURCOMLLC = AT(",", FILNAMSLLC, I)
IF CURCOMLLC = 0
   CURCOMLLC = LEN(FILNAMSLLC) + 1
ENDIF
FILNAMLLC = SUBSTR(FILNAMSLLC, PRVCOMLLC, ( CURCOMLLC - PRVCOMLLC ))
IF NOT USED(FILNAMLLC)
   USE (FILNAMLLC) IN 0
ENDIF
PRVCOMLLC = CURCOMLLC + 1
RETURN

*** GET FIELD LIST FOR FILNAMLLC
FUNCTION GETFLDNLLC

SELECT (FILNAMLLC)
DELETE FILE FLDSEX.DBF
* CREATES A FILE WITH A LIST OF FIELDS
COPY STRUCTURE EXTENDED TO FLDSEX
* TRANSFER FILNAMLLC FIELD NAMES TO FLDLIST
SELECT FLDLIST
APPEND FROM FLDSEX
* REPLACE FIELDNAME WITH FILE.FIELDNAME
REPLACE FIELD_NAME WITH ( FILNAMLLC + "." + FIELD_NAME ) FOR ( AT(".", FIELD_NAME) = 0 )
RETURN

*** GET FROM-TO DELIMITERS
FUNCTION FTDELIMLLC

DO CASE
   CASE ( FIELD_TYPE = "C" ) OR ( FIELD_TYPE = "M" )
      DELIM1LLC = '"'
      DELIM2LLC = '"'
   CASE FIELD_TYPE = "D"
      DELIM1LLC = "{"
      DELIM2LLC = "}"
   OTHERWISE
      DELIM1LLC = ""
      DELIM2LLC = ""   
ENDCASE
RETURN

*** UNSTRING PARENT AND RELATION FROM RELATNLLC
FUNCTION UNPARELLLC

PARCOMLLC = AT(",", RELATNLLC, ( ( I * 2 ) - 3 ))
RELCOMLLC = AT(",", RELATNLLC, ( ( I * 2 ) - 2 ))
IF RELCOMLLC = 0
   RELCOMLLC = LEN(RELATNLLC) + 1
ENDIF
PARFILLLC = SUBSTR(RELATNLLC, PARPCOMLLC, ( PARCOMLLC - PARPCOMLLC ))
RELINDXLLC = SUBSTR(RELATNLLC, ( PARCOMLLC + 1 ), ( RELCOMLLC - PARCOMLLC - 1 ))
PARPCOMLLC = RELCOMLLC + 1
* FIND KEY NAME FOR TAG OR INDEX NAME - SET RELATION & WHERE CLAUSES NEED FIELD NAME INSTEAD OF TAG NAME
SELECT (FILNAMLLC)
FOR K = 1 TO 256
    IF TAG(K) = RELINDXLLC
       RELFLDLLC = KEY(K)
       EXIT
    ENDIF
NEXT K
RETURN